Infrastructure - Task #1531

Story # 1530 (Closed): Redefine interface definitions to correspond with Tiers

Create d1_common_java tier-based interfaces
2011-05-06 19:13 - Matthew Jones

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Nicholas Dexter % Done: 100%

Category: d1_common_java Estimated time: 0.00 hour

Target version: Sprint-2011.26-Block.4

Milestone: 2011-Block-3 Story Points:

Product Version: *

Description

Related issues:

Blocks Infrastructure - Feature #1605: update implementations of 0.6.2 interf... Closed 2011-06-06

History

#1 - 2011-05-06 19:14 - Matthew Jones

- Subject changed from Create di_common tier-based interfaces to Create d1_common_java tier-based interfaces

#2 - 2011-05-06 19:16 - Matthew Jones

New interface definitions should be created. They are described here:
http: . ne.org/cicore-interf -pack

But also copied here for reference:

New CN Interfaces http:/mule1.dataone.org/ArchitectureDocs-current/apis/CN_APIs.html

org.dataone.service.cn.tier1.Core
org.dataone.service.cn.tier1.Read
org.dataone.service.cn.tier2.ldentity
org.dataone.service.cn.tier2. Authorization
org.dataone.service.cn.tier2.Register

org.dataone.service.cn.tier3.Replication (renamed from org.dataone.service.cn.tier4.Storage)

New MN Interfaces hitp:/mulei.dataone.org/ArchitectureDocs-current/apis/MN_APIs.html

org.dataone.service.mn.tier1.Core
org.dataone.service.mn.tier1.Read
org.dataone.service.mn.tier2.Authorization
org.dataone.service.mn.tier3.Storage
org.dataone.service.mn.tier4.Replication
http://epad.dataone.org/cicore-interfaces-packages
http://mule1.dataone.org/ArchitectureDocs-current/apis/CN_APIs.html
http://mule1.dataone.org/ArchitectureDocs-current/apis/MN_APIs.html

#3 - 2011-05-06 19:19 - Matthew Jones
- Category set to d1_common_java

- Milestone set to 2011-Block-3

#4 - 2011-05-06 19:57 - Matthew Jones

Reconisdered naming of the interfaces to make the names unambiguous (e.g., to differentiate CN Read from MN Read):

New CN Interfaces http:/mulei.dataone.org/ArchitectureDocs-current/apis/CN_APIs.html

org.dataone.service.cn.tier1.CNCore

org.dataone.service.cn.tier1. CNRead

org.dataone.service.cn.tier2.CNIdentity

org.dataone.service.cn.tier2. CNAuthorization

org.dataone.service.cn.tier2. CNRegister

org.dataone.service.cn.tier3.CNReplication (renamed from org.dataone.service.cn.tier4.Storage)

New MN Interfaces http:/mulei.dataone.org/ArchitectureDocs-current/apis/MN_APIs.html

org.dataone.service.mn.tier1.MNCore
org.dataone.service.mn.tierl. MNRead
org.dataone.service.mn.tier2. MNAuthorization
org.dataone.service.mn.tier3.MNStorage
org.dataone.service.mn.tier4. MNReplication

#5 - 2011-05-07 02:02 - Matthew Jones

- Status changed from New to In Progress

#6 - 2011-05-07 02:03 - Matthew Jones
- % Done changed from 0 to 20

Created inital CN tier interfaces. Still need to do MN interfaces, and resolve missing Type definitions.

#7 - 2011-05-24 12:37 - Nicholas Dexter
- % Done changed from 20 to 50

In looking at the CN API Architecture Docs and the existing CN java interfaces, | could not find the CNStorage.java and could not find mention of
CNReplication or CNIdentity in the documentation. Either the documentation is out of date or the interfaces themselves are.

Also, the docs list tiers 1, 2, and 4, not 3, and tier4's CN_storage should be CNReplication as Matt has specified in the earlier notes.

#8 - 2011-05-24 14:01 - Dave Vieglais

Docs were out of date.
Also notice that there's no payload defined for CNRegister.register(). Adding a separate task to flesh that out ( #1587 ).

#9 - 2011-05-24 14:29 - Dave Vieglais

Question on the tiers - these are supposed to reflect overall functionality expressed by the infrastructure across MNs and CNs. Tier 4 is where
replication support is available for MNs but the suggested changes place replication at tier3 for the CNs which is a bit misleading.

#10 - 2011-05-26 19:25 - Nicholas Dexter
- % Done changed from 50 to 80

CNCore.registerSystemMetaData return type, setting void for now, but API docs specify ?? return type.
CNildentity.getSubjectinfo doc only has ServiceFailure and InvalidToken, also needs NotAuthorized and Notimplemented. Update docs to reflect.
CNReplication.updateReplicationMetadata is missing a return type, setting to void for now.

CNRegister.* make reference to capabilities, need type here.

#11 - 2011-05-31 16:46 - Nicholas Dexter

- Assignee changed from Matthew Jones to Nicholas Dexter

#12 - 2011-06-27 16:41 - Nicholas Dexter
- translation missing: en.field_remaining_hours changed from 1.0 to 0.0
- % Done changed from 80 to 100

- Status changed from In Progress to Closed
